

CON
          _clkmode = xtal1 + pll16x
          _xinfreq = 5_000_000                                          ' use 5MHz crystal
        
          clk_freq = (_clkmode >> 6) * _xinfreq                         ' system freq as a constant
          mSec     = clk_freq / 1_000                                   ' ticks in 1ms
          uSec     = clk_freq / 1_000_000                               ' ticks in 1us
        

        'pin assignments:        
  
        PinADCdata    = 7     
        PinADCclk     = 9     
        PinADCcs      = 8

        PinRIOslc     = 10               
        PinRIOsda     = 11
        
        PinQuadA      = 20
        PinQuadB      = 21
        PinRFIDser    = 22
        PinRFIDen     = 23
        PINfreqCount  = 24
        PINservo      = 25
        PINpumpImp    = 26
        PINignt       = 27

        
        'remote digital io assignments
        MCP32017addr  = %010
                         
        CintDinATrayIs  = 0       'Digital inputs on bank A
        CintDinAHolder  = 1
        CintDinATBN01   = 2
        CintDinATBN02   = 3
        CintDinAPIR01   = 4
        CintDinAMic     = 5
        CintDinALaser   = 6
        CintDinATBN04   = 7
       
        intDoutIrish   = 0        'Digital outputs on bank B
        'parameters
        


VAR
        
        'Variables to hold I/O values
        '============================
        
        'ADC analogue input values - obeying the requirement for declaring 8 consecutive LONGs to make it easy for the ADC scanner object       
        LONG gAnLevelWater           
        LONG gAnTempWater            
        LONG gAnPressWater           
        LONG gAnLigth       
        LONG gAnWeightCup            
        LONG gAnVoltageSupply                                              
        LONG gAnCh6               
        LONG gAnCh7
        '----------------------------------------------------------------------------------------------------------------------------------
        
        LONG gHWCmode
        LONG gQuadPos
        LONG intMatch
        
        LONG intOutA                      'NEW
        LONG intOutB
        LONG intInA
        LONG intInB        
        LONG intTrayIs
        LONG intIrish        
        LONG gAnUVflame
        LONG gAnHeatServo
        
        BYTE strnRFID[11]


   
OBJ

 adc     : "ADCreaderConv"
 val     : "ValueMonitor"
 hwc     : "HeatWaterControl"
 quad    : "QuadDecoder"
 rfid    : "RfidReader"
 vm2     : "TestVM2"
 oled    : "TestOLED"
 drw     : "DioReadWriter"
  
PUB Main

'start ad converter reader
  adc.startx(PinADCcs, PinADCclk, pinADCdata, 8, @gAnLevelWater)        'gAnLevelWater is the first in the block of 8 LONGs
  WAITCNT(clkfreq + CNT)
   
'configure and start digital io readwriter                                                                            
   drw.Init(PinRIOslc, PinRIOsda, 2, %1111_1111, %0000_0000, %0000_0000, %0000_0000)
   drw.Start(PinRIOslc, PinRIOsda, 2, @intOutA, @intOutB, @intInA, @intInB)
   WAITCNT(clkfreq + CNT)                                                             'Wait for the Dio to rev up    
 
'start monitor
   val.start(@gAnLevelWater, 10)

   intTrayIs:= intInA & |< CintDinATrayIs                                             'Reads one bit value from Long at given bit position
   intOutB:=   Wr_bit(intOutB, intDoutIrish, intIrish)                                'Writes one bit value into Long at given bit postion  
  

 'start rotary Gray decoder
   quad.start(PinQuadA, @gQuadPos)

 'start RFID reader
   rfid.start(PinRFIDser, PinRFIDen, @strnCodes, 7, 10, 0, @intMatch, @strnRFID)

 ' IF intMatch > 0
 '      vm2.demo  

   repeat until gQuadPos <> 0
  

'start hotwatercontrol
   gHWCmode:= 1


 '            PINpump, PINignt, PINservo, PINfreqCount{NEW}, ptrTempWater, ptrPressWater, ptrFlameRate, ptrLevelWater, ptrHeatServo, ptrOpmode, iSPtemp, iSPpress, iSPtime, iSPvol
    hwc.Start(PINpumpImp, PINignt, PINservo, PINfreqCount, @gAnTempWater, @gAnPressWater, @gAnUVflame, @gAnLevelWater, @gAnHeatServo, @gQuadPos{@gHWCmode}, 93, 1500, 25, 3000)
 
   oled.demo

  'watchdog
  DIRA[5]~~
  repeat until gQuadPos == 3
      
    !OUTA[5]    
    WAITCNT(clkfreq/5 + cnt)


     
PRI Wr_bit(target, pos, value)    'Writes value.0 to target.pos                                         'NEW

   if (value & 1)
     return target | (1 << pos)
   else
     return target & !(1 << pos)
 

 
DAT
strnCodes    BYTE  "0100A648BD", 0     {Erlend}
             BYTE  "0100E3E9CB", 0     {Lisa}
             BYTE  "8400338B3C", 0     {Mathias}
             BYTE  "8400336BB8", 0     {Irene}
             BYTE  "8400338FC0", 0     {Keith}
             BYTE  "8400338778", 0     {Guest1}
             BYTE  "8400338778", 0     {Guest2}             
                   
intCodes     LONG  7
           
        